package de.hdm_stuttgart.battlearena.Controller;

import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;
import javafx.stage.Stage;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Objects;
import java.util.ResourceBundle;

public class IntroController implements Initializable {

    @FXML
    public MediaView introMediaView;
    @FXML
    public BorderPane introParent;

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        introParent.setStyle("-fx-background-color: black;");
        File file = new File("src/main/resources/textures/videos/monke.mp4");
        Media media = new Media(file.toURI().toString());
        MediaPlayer mediaPlayer = new MediaPlayer(media);
        introMediaView.setMediaPlayer(mediaPlayer);

//      resizing once the scenes has been loaded to get width and height property
        mediaPlayer.setOnReady(() -> {
            introMediaView.fitWidthProperty().bind(introParent.getScene().widthProperty());
            introMediaView.fitHeightProperty().bind(introParent.getScene().heightProperty());
        });

        mediaPlayer.setVolume(1);
        mediaPlayer.setAutoPlay(true);

//        TODO: make any button pressed work
        introParent.setOnMouseClicked((mouseEvent) -> {
            mediaPlayer.dispose();
            videoEnd();
        });
        mediaPlayer.setOnEndOfMedia(this::videoEnd);
    }

    //    TODO: maybe look into using SceneLoader class
    private void videoEnd() {
        try {
            Parent root = FXMLLoader.load(Objects.requireNonNull(getClass().getResource("/fxml/MenuBorderPane.fxml")));
            Stage stage = (Stage) introParent.getScene().getWindow();
            Scene scene = new Scene(root);
            scene.getStylesheets().add(Objects.requireNonNull(this.getClass().getResource("/styles/style.css")).toExternalForm());
            stage.setScene(scene);
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }
}
